/*
 * wysmod - init.c
 * 	version 0.0.0
 * 
 * Copyright (C) 2005, 2006, 2007  Krzysztof Mazur <krzysiek@podlesie.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <tmos/kernel.h>
#include <asm/aduc841.h>
#include <asm/jiffies.h>

void __barrier(void) __naked
{
}

char _sdcc_external_startup(void);

char _sdcc_external_startup(void)
{
#if CONFIG_XDATA && CONFIG_ADUC841
	CFG841 |= CFG841_XRAMEN;
#endif
	return 0;
}

void arch_init(void)
{
	TCON = 0;
	IE = 0x00;
#if CONFIG_ADUC841
	IEIP2 = 0xa0;
#endif
#if CONFIG_I51_GROUND_PORT0
	P0 = 0;
#endif

#ifdef CONFIG_X2
	CLKREG |= CLKREG_X2;
#endif
#ifdef CONFIG_JIFFIES
	jiffies_init();
#endif
#ifdef CONFIG_PAGE_ALLOC
	/* allocate first page */
	page_alloc();
#endif
}
