/*
 * tmos - tsc_read.c
 * 
 * Copyright (C) 2005, 2006, 2007  Krzysztof Mazur <krzysiek@podlesie.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <tmos/kernel.h>
#include <tmos/config.h>
#include <tmos/jiffies.h>
#include <asm/8051.h>

u16 tsc_read(void)
{
	u8 low;
	u8 high;

	do {
		high = TH0;
		low = TL0;
	} while (high != TH0);
	return pack16(low, high);
}

u16 tsc_read_low(void) __using(LOW_PRIORITY_BANK)
{
	u8 low;
	u8 high;

	do {
		high = TH0;
		low = TL0;
	} while (high != TH0);
	return pack16(low, high);
}
