/*
 * tmos - mb-slave.c
 * 	version 0.0.0
 *
 * 	Generic modbus slave
 * 
 * Copyright (C) 2005..2009  Krzysztof Mazur <krzysiek@podlesie.net>
 * Copyright (C) 2006, 2007, 2009  Marek Piwonski <marek@microster.pl>
 * Copyright (C) 2006  Krzysztof Kasperski <casper@microster.pl>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __TMOS_MB_SLAVE_H
#define __TMOS_MB_SLAVE_H

#include <tmos/types.h>

/*
 * 8-bit data block addresses are sufficient for most applications
 * an
 */
#if CONFIG_MB_SLAVE_SHORT_ADDR
typedef uint8_t mb_addr_t;
#else
typedef uint16_t mb_addr_t;
#endif

typedef uint8_t mb_size_t;

typedef uint8_t mb_ex_t;

void mb_slave_recv(void) __reentrant;

#ifdef CONFIG_MB_SLAVE_HOLDING_REGISTERS
mb_ex_t mb_slave_hr_read(uint16_t __kernel *v, mb_addr_t addr,
		mb_size_t len) __reentrant;
mb_ex_t mb_slave_hr_write(const uint16_t __kernel *v, mb_addr_t addr,
		mb_size_t len) __reentrant;
#endif

#ifdef CONFIG_MB_SLAVE_INPUT_REGISTERS
mb_ex_t mb_slave_ir_read(uint16_t __kernel *v, mb_addr_t addr,
		mb_size_t len) __reentrant;
#endif

#endif
